export default function getFroms(product: string, releaseTo: number) {
  //The launcher (patcher, patcher2014, patcher2017) is always installing from -1, never from a previous version
  if (product.startsWith('patcher')) {
      return [-1];
  } else {
      const froms: number[] = [];

      //always X-1toX
      froms.push(releaseTo - 1);

      //also 0toX, unless X is 0
      if (releaseTo >= 2) { froms.push(0); }

      if ((releaseTo % 5) === 0) {
          //also X-5toX if X % 5
          if (releaseTo >= 10) { froms.push(releaseTo - 5); }
          //also X-20toX if X % 5
          if (releaseTo >= 25) { froms.push(releaseTo - 20); }
          //also downgrade from the following four releases
          froms.push(releaseTo + 1);
          froms.push(releaseTo + 2);
          froms.push(releaseTo + 3);
          froms.push(releaseTo + 4);
      } else { //for some of the older releases, an update from _5 or _0 is possible
          /*
          e.g. in asset_swtor_main:
          5to7, 5to8, 5to9,
          10to12, 10to13, 10to14,
          15to17, 15to18, 15to19,
          20to22, 20to23, 20to24,
          25to27, 25to28, 25to29,
          30to32, 30to33, 30to34,
          35to37, etc.  , 85to87
          */
          if (releaseTo >= 7 && (releaseTo % 5) > 1) { froms.push(releaseTo - (releaseTo % 5)); }
      }

      return froms;
  }
}
